/***********************************************************************/
/*                                                                     */
/*                              Pio (C++)                              */
/*                                                                     */
/*                    Polyglot Input/Output Library                    */
/*                                                                     */
/*                       EPI Serena, INRIA Paris                       */
/*                                                                     */
/*  Copyright (c) 2005-2017 INRIA.                                     */
/*  Institut National de Recherche en Informatique et en Automatique.  */
/*  All rights reserved. This file is distributed only by permission.  */
/*                                                                     */
/*  Estelle Marchand <Estelle.Marchand@inria.fr>                       */
/*                                                                     */
/***********************************************************************/

/* $Id: service.hpp,v 1.13 2017/05/31 15:54:21 fclement Exp $ */

#include "typed_value.hpp"

#ifndef _SERVICE_H
#define _SERVICE_H

namespace io{
  
  class Service{
    vector<Typed_value>  _values;
    string _atom;
  public:
    Service(string at="");
    string atom();
    Service(vector<Typed_value> &,string at="");
    Service(const Typed_value &,string at="");
    virtual ~Service();
    void add(const Typed_value&);
    vector<Typed_value>& values();
  };
  
  
}


#endif
