/***********************************************************************/
/*                                                                     */
/*                              Pio (C++)                              */
/*                                                                     */
/*                    Polyglot Input/Output Library                    */
/*                                                                     */
/*                       EPI Serena, INRIA Paris                       */
/*                                                                     */
/*  Copyright (c) 2005-2017 INRIA.                                     */
/*  Institut National de Recherche en Informatique et en Automatique.  */
/*  All rights reserved. This file is distributed only by permission.  */
/*                                                                     */
/*  Estelle Marchand <Estelle.Marchand@inria.fr>                       */
/*                                                                     */
/***********************************************************************/

/* $Id: task.hpp,v 1.13 2017/05/31 15:54:21 fclement Exp $ */

#include "typed_value.hpp"

#ifndef _TASK_H
#define _TASK_H

namespace io{
  
 
  class Task{
    string task_name;
    unsigned int _n_args;
    vector<Typed_value> task_args;
    bool is_set;
  public:
    string name();
    Task();
    Task(string _name,vector<Typed_value> & arg);
    Task(string _name,const Typed_value& arg);
    Task(string _name,int n);
    virtual ~Task();
    int n_args();
    vector<Typed_value> & args();
    void set_args(vector<Typed_value>& new_arg);
    void set_arg(const Typed_value& new_arg);
  };
  
}


#endif
