(***********************************************************************)
(*                                                                     *)
(*                                Sklml                                *)
(*                                                                     *)
(*                 The OCaml parallel skeleton system                  *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2007-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Quentin Carbonneaux                                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(*  This example is based on an example designed for OCamlP3l.         *)
(*                                                                     *)
(***********************************************************************)

(* $Id: make_dd2.mli,v 1.1 2017/01/05 16:23:14 fclement Exp $ *)

val set_data : Rdec2.t -> Subdomain.t array;;

val subdomain_worker :
  Dd_config.t -> Rdec2.subdomain ->
  (Unatural.t * Subdomain.t) list -> Subdomain.t * Subdomain.t
;;

val plot : Dd_config.t -> Rdec2.t -> Subdomain.t array -> Subdomain.t array;;

val convergence : Dd_config.t -> Subdomain.t array -> bool;;

val print_result : Dd_config.t -> string -> unit;;
