(***********************************************************************)
(*                                                                     *)
(*                                Sklml                                *)
(*                                                                     *)
(*                 The OCaml parallel skeleton system                  *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2007-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Quentin Carbonneaux                                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(*  This example is based on an example designed for OCamlP3l.         *)
(*                                                                     *)
(***********************************************************************)

(* $Id: subdomain.mli,v 1.4 2017/01/05 16:00:22 fclement Exp $ *)

(** {3 Operations on subdomains} *)

open Rdec2;;

type t =
  {
   bd : boundary;
   err : float * float;
  }
and subdomain = t
;;

(** {6 Extraction} *)

val get_bds : t array -> boundary array;;
val get_errs : t array -> (float * float) array;;

val get_max_errs : t array -> float * float;;

(** {6 Insertion} *)

val set_bds : boundary array -> t array -> unit;;

val init : boundary -> t;;

(**/**)
(** {6 Undocumented features} *)

val max_err : float * float -> t -> float * float;;
