(***********************************************************************)
(*                                                                     *)
(*                                Sklml                                *)
(*                                                                     *)
(*                 The OCaml parallel skeleton system                  *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2007-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Quentin Carbonneaux                                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: main.ml,v 1.9 2017/01/04 11:58:31 fclement Exp $ *)

module Co = Ucommand_option;;

let main { Parfun.parfun = parfun; } =
  Co.parse ();
  let nw = Sklml_options.get_number_of_workers () in
  Algo.algo (Make_skl.heavy_comps parfun nw);
  exit 0;
;;

Parfun.pardo main;;
