(***********************************************************************)
(*                                                                     *)
(*                                Sklml                                *)
(*                                                                     *)
(*                 The OCaml parallel skeleton system                  *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2007-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Quentin Carbonneaux                                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: black_box.ml,v 1.8 2017/01/04 11:58:31 fclement Exp $ *)

module W = Wrapper;;
module Opt = Options;;

let piob_ref = ref None;;

let pf = Pio.foreman_make_printing_facilities ();;

let wrap tw =
  let cmd = Opt.get_external_program_command () in
  Pio.foreman_wrap_task cmd piob_ref tw
;;

let init x = wrap (W.make_init_wrapper pf "init") x;;

let light_comp x = wrap (W.make_light_comp_wrapper pf "light_comp") x;;

let heavy_comp x = wrap (W.make_heavy_comp_wrapper pf "heavy_comp") x;;

let final x = wrap (W.make_final_wrapper pf "final") x;;
