(***********************************************************************)
(*                                                                     *)
(*                                Sklml                                *)
(*                                                                     *)
(*                 The OCaml parallel skeleton system                  *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2007-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Quentin Carbonneaux                                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: worker.mli,v 1.6 2017/01/04 11:58:31 fclement Exp $ *)

type init_engine = Pio.spf -> unit -> int list
and comp_engine = Pio.spf -> int -> int
and final_engine = Pio.spf -> unit -> unit
;;

type task_engines =
  {
   init_engine : init_engine;
   light_comp_engine : comp_engine;
   heavy_comp_engine : comp_engine;
   final_engine : final_engine;
  }
;;

type tasks =
  {
   init : (unit, int list) Pio.task;
   light_comp : (int, int) Pio.task;
   heavy_comp : (int, int) Pio.task;
   final : (unit, unit) Pio.task;
  }
;;

val make_tasks : task_engines -> tasks;;

val main_loop : tasks -> unit;;
