(***********************************************************************)
(*                                                                     *)
(*                                Sklml                                *)
(*                                                                     *)
(*                 The OCaml parallel skeleton system                  *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2007-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Quentin Carbonneaux                                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: unix_print.ml,v 1.3 2017/01/04 11:58:29 fclement Exp $ *)

(* This one is manually edited! With help from OCamlGen... *)

let printer_inet_addr _ctx ppf addr =
  Format.fprintf ppf "%S" (Unix.string_of_inet_addr addr)
;;

let printer_sockaddr ctx ppf = function
  | Unix.ADDR_UNIX s ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Unix.ADDR_UNIX";
    Og_printer.printer_String Og_precedence.Ck_argument ppf s;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Unix.ADDR_INET (u_i, i) ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Unix.ADDR_INET";
    Format.fprintf ppf "%, (@,";
    Format.fprintf ppf "%,@[<hv 0>";
    printer_inet_addr Og_precedence.Ck_tuple_item ppf u_i;
    Format.fprintf ppf "%,,@ ";
    Og_printer.printer_Int Og_precedence.Ck_tuple_item ppf i;
    Format.fprintf ppf "%,@]";
    Format.fprintf ppf "%,@;<0 -2>)";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

(* Defining top printers. *)

let print_inet_addr = printer_inet_addr Og_precedence.Ck_toplevel

and print_sockaddr = printer_sockaddr Og_precedence.Ck_toplevel
;;
