(***********************************************************************)
(*                                                                     *)
(*                                Sklml                                *)
(*                                                                     *)
(*                 The OCaml parallel skeleton system                  *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2007-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Quentin Carbonneaux                                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: node.mli,v 1.17 2017/01/04 11:58:30 fclement Exp $ *)

open Tools_common_types;;

type addr = string;;

type node =
  {
   name : string;
   host : string;
   shell : string;
   color : color;
   daemon_path : string;
   program_path : string option;
  }
;;

type master_node = node
and slave_node = node
;;

val mk_master : Options.t -> Parsers.configuration_settings -> master_node;;
val mk_slave : Options.t -> Parsers.configuration_settings -> slave_node;;

val mk_addr : master_node -> port -> addr;;

val compile_master :
  Options.t -> number_of_workers -> master_node -> Batch.t
;;
val compile_slaves :
  Options.t -> master_node -> port -> slave_node Ulist1.t -> Batch.t
;;
