(***********************************************************************)
(*                                                                     *)
(*                                Sklml                                *)
(*                                                                     *)
(*                 The OCaml parallel skeleton system                  *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2007-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Quentin Carbonneaux                                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: options.mli,v 1.12 2017/01/24 17:10:10 weis Exp $ *)

open Tools_common_types;;

val services : 'a tagged_services;;

type t =
  {
   maximum_error_message_length : length;
   daemon_path : string option;
   timeout : timeout;
   sklml_program_command_line : string array;
  }
and options = t
;;

type sections = string;;

val parse : unit -> t * sections;;
