(***********************************************************************)
(*                                                                     *)
(*                                Sklml                                *)
(*                                                                     *)
(*                 The OCaml parallel skeleton system                  *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2007-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Quentin Carbonneaux                                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: tio.mli,v 1.22 2017/01/04 11:58:30 fclement Exp $ *)

open Tools_common_types;;

type tic;;

type 'a t =
  | Line of 'a
  | Eof
  | Timeout
and 'a tio = 'a t
;;

exception Tio_error of string;;

val tic_of_in_channel : in_channel -> tic;;
val input : tic -> Ubytes.t -> offset -> length -> timeout -> length t;;
val input_char : tic -> timeout -> char t;;
val input_line : tic -> timeout -> string t;;

val skip_n_input_lines : tic -> Unatural.t -> timeout -> string t;;
