(***********************************************************************)
(*                                                                     *)
(*                                Sklml                                *)
(*                                                                     *)
(*                 The OCaml parallel skeleton system                  *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2007-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Quentin Carbonneaux                                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: sklml_mode.ml,v 1.6 2017/01/04 11:58:30 fclement Exp $ *)

module Perv = Upervasives;;

open Tools_common_types;;

let qual = Perv.qualify "Mode";;
let failwith = Perv.failwith_qual qual;;

let string_of_semantics_mode = function
  | Seq -> "seq"
  | Par -> "par"
;;

let semantics_mode_of_string = function
  | "seq" | "Seq" | "SEQ" | "s" | "S" -> Seq
  | "par" | "Par" | "PAR" | "p" | "P" -> Par
  | s ->
      failwith
        "semantics_mode_of_string"
        (Printf.sprintf "unbound semantics mode %S" s)
;;

let other_compilation_mode = function
  | Byt -> Bin
  | Bin -> Byt
;;

let doc_string_of_compilation_mode = function
  | Byt -> "bytecode compilation mode"
  | Bin -> "native-code compilation mode"
;;
