(***********************************************************************)
(*                                                                     *)
(*                                Sklml                                *)
(*                                                                     *)
(*                 The OCaml parallel skeleton system                  *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2007-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Quentin Carbonneaux                                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: tools_main.ml,v 1.14 2017/01/04 11:58:30 fclement Exp $ *)

module Nat = Unatural;;

let _0_ = Nat._0_;;

let nat_sys_command cmd =
  let ier = Sys.command cmd in
  assert (ier >= 0);
  (* Now, we have ier >= 0.
     Therefore, the next Nat.unsafe_of_int will be safe. *)
  Nat.unsafe_of_int ier
;;

let main { Tools_common_types.report; debug; error; } parse mk_command =
  let options = parse () in
  report "generating command line";
  let cmd = mk_command options in
  debug (Printf.sprintf "will run\n  %s" cmd);
  report "running command line";
  let ier = nat_sys_command cmd in
  if ier > _0_ then error "see message above" ier else begin
    report "finished"; exit 0
  end
;;
